;"Mort aux vaches, mort aux lois, vive l'anarchie!" ;)
;-Georges Brassens
llenarMesa:
	ld bc,tablaDeCabezas
llenarMesaBucle:
	ld a,(tablaDeCabezas+18)&$FF	;verificar si hemos llegado
	cp c							;al fin de la tabla
	 ret z
	ld a,(bc)						;leer el próximo byte para ver si la pasma se está mostrando la cabezota
	inc bc
	inc bc
	or a
	 jr z,llenarMesaBucle
;dibujar esa cara fea!
	ld l,c							;ld hl,bc
	ld h,b
	dec l							;dec hl
	dec (hl)						;contador-1
	ld a,(hl)
	cp 25
	 jr nc,noAccion
	or a
	 jr nz,$+7
		dec l
		ld (hl),0					;si contador = 0, borrar la cara
		jr noAccion
	push bc
		ld ix,pistola
		ld d,4

		bit 4,a
		 call z,disparar
		call getCaraFila				;devuelve la fila de la cara actual en b (1-3)
		ld hl,mapaYOff
		ld a,6
		add a,(hl)
			add a,16
		 djnz $-2
		ld b,d
		sub d
		ld e,a

		ld a,(96/2)-8
		call dibSprite_var
	pop bc
noAccion:
	ld a,c
	sub (tablaDeCabezas+2)&$FF		;+2 por los dos inc bc's

	ld de,12*17
	ld hl,gbuf+MESA_X+(8*12)-(12*17);-12*17 porque vamos a añadir 12 antes de empezar

	add hl,de
	sub 6
	 jr nc,$-3						;si no carry, está en la próxima fila
	 jr z,$-5						;lo mismo con z
	add a,6							;para compensar por el sub 6
	ld e,a							;la columna (0, 2, 4: el sprite = 16 pixeles (2 bytes))
	add hl,de						;hl = posición en el gbuf
	ld de,cabeza_de_mierda			;el sprite que vamos a dibujar
	push bc
		ld b,16
dibujarCaraBucle:
		push bc
			ld a,(de)
			or (hl)
			ld (hl),a
			inc hl
			inc de
			ld a,(de)
			or (hl)
			ld (hl),a
			inc hl
			inc de
			ld bc,12-2
			add hl,bc
		pop bc
		djnz dibujarCaraBucle
	pop bc
	jr llenarMesaBucle

getCaraFila:
	ld a,c
	sub (tablaDeCabezas+1) & $FF
	ld b,0
		inc b
		sub 6
	 jr nc,$-3
	ret

disparar:
	ld ix,pistola+4			;segunda animación de la pistola
	ld d,6
	and $7
	 ret nz
	ld hl,tablaDeBalas-5
	ld de,5					;cada bala ocupa 5 bytes

	add hl,de
	ld a,(hl)
	or a
	 jr nz,$-3

	ld (hl),1				;encender
	inc hl
	ld (hl),(96/2)-7		;x
	inc hl
	ld b,24
	call aleatorio
	sub 12
	ld (hl),a				;y vel
	inc hl
	ld a,(mapaYOff)
	rrca
	rrca
	rrca					;los primeros 5 bits sirven de fracción
	ld (hl),a				;y offset
	inc hl
	ld a,(mapaY)
	ld d,a
	call getCaraFila
	xor a
		add a,2
	 djnz $-2
	add a,d
	ld (hl),a
	ld d,6
	ret

dibMesa:
	ld hl,gbuf+(7*12)+MESA_X
	call mesaHoriz
	ld c,3
mesaLados:
	ld a,16
mesaLadoFuera:
	ld b,3
mesaLadoDentro:
	ld (hl),$80
	inc hl
	ld (hl),$01
	inc hl
	djnz mesaLadoDentro
	add hl,de
	dec a
	 jr nz,mesaLadoFuera
	call mesaHoriz
	dec c
	 jr nz,mesaLados
	ret

;dibujar una línea horizontal
mesaHoriz:
	ld a,$FF
	ld b,MESA_ANCHO
ponerMesa:
	ld (hl),a
	inc hl
	djnz ponerMesa
	ld de,12-MESA_ANCHO
	add hl,de
	ret

anadirCara:
	ld b,250
	call aleatorio
	cp 9
	 ret nc
	or a
	rla
	ld e,a
	ld d,0
	ld hl,tablaDeCabezas
	add hl,de
	ld a,(hl)
	or a
	 ret nz
	ld (hl),1
	inc hl
	ld b,50
	call aleatorio
	add a,50
	ld (hl),a			;contador
	ret
