REJAS_Y = 20
REJAS_X = 2

titulo:
	call soltarTeclas				;no comenzar hasta que todas las teclas han sido sueltas
	xor a
	ld (counter),a
;	ld (mapaYOff),a
tituloBucle:
	call gbufCopy
	call gbufNegro

	ld hl,liberteTxt
	ld bc,$040E
	ld (penCol),bc
	bcall(_VPutS)

	ld bc,$3414
	ld (penCol),bc
	bcall(_VPutS)

	call fijarXOR
		ld de,$3633
		ld (penCol),de
		ld hl,(highScore)
		ld a,(highScore+2)
		call num2String
		call dibNumero
	call fijarOR

	ld hl,gbuf+(REJAS_Y*12)+REJAS_X
	call lineaBlanca
	ld e,4
	ld d,0
	ld a,%11011101
	ld c,16
rejasBucle:
	ld b,8
	add hl,de
	inc hl
	ld (hl),a
	djnz $-2
	dec c
	jr nz,rejasBucle
	add hl,de
	inc hl
	call lineaBlanca

	ld hl,gbuf+((REJAS_Y+1)*12)+REJAS_X+1
	ld a,(counter)
	ld c,a
	and %11000000
	rlca
	rlca
	add a,a
	ld e,a
	ld d,0
	add hl,de
	call abrirRejas
;actualizar contador
	ld hl,counter
	ld a,(hl)
	and %11000000
	ld b,a
	ld a,(hl)
	add a,3
	and %00111111
	add a,b
	ld (hl),a
	rlca
	rlca
	and $3
	push af
		add a,a
		ld hl,menu
		ld c,a
		ld b,0
		add hl,bc
;sacar la dirección del texto
		ld a,(hl)
		inc hl
		ld h,(hl)
		ld l,a
;mostrar texto
		ld bc,(REJAS_Y+20)*256+30
		ld (penCol),bc
		bcall(_VPutS)
	pop de				;d = contador (0-3)

;leer clear
	call leerClear
	 ret z

;leer 2nd
	call leer2nd
	 jr nz,verFlechas
	ld a,(counter)
	rlca
	rlca
	and $3
	 jp z,nuevaPartida	;si counter=0, iniciar una nueva partida
	dec a
						;no sé qué será esta opción
	dec a
	 ret z
verFlechas:
;procesar las flechas
	call leerFlechas

;********************
	ld hl,tituloBucle
	push hl
;********************

;esperar antes de leer la próxima tecla
	ld hl,teclaPulsada
	cp $FF
	 jr nz,$+4
		ld (hl),-1
	ex af,af'
		ld a,(hl)
		inc (hl)
		and $F
		 ret nz
	ex af,af'
	ld hl,counter
	ld b,%01000000
	rra					;abajo
	rra					;izquierda
	 jr c,tituloDer
		ld a,d
		or a
		 ret z
		ld a,(hl)
		sbc a,b
		and %11000000
		ld (hl),a
		ret
tituloDer:
	rra
	 ret c
		ld a,d
		cp 2
		 ret z
		ld a,(hl)
		add a,b
		and %11000000
		ld (hl),a
	ret

lineaBlanca:
	ld (hl),0
	ld e,l
	ld d,h
	inc de
	ld bc,7
	ldir
	ret

abrirRejas:
	ex de,hl
	ld hl,rejas
	bit 5,c
	 jr z,$+5
		ld hl,rejas+32
	ld a,16			;sprites tienen una altura de 4 pixeles
abrirRejasBucle:
	ldi			;copiar sprite al gbuf
	ldi
	ex de,hl
		ld bc,10
		add hl,bc
	ex de,hl
	dec a
	 jr nz,abrirRejasBucle
	ret
